<?php
/*
 * @package Open graph facebook
 * @version 0.01
 * @Author:dhayzon /www.dhayzon.com
 * @copyright Copyright (C) 2016, Dahyzon
 * @All rights reserved. 
 * @This SMF modification is subject to the BSD  License
 */

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
elseif (!defined('SMF'))
	exit('<b>Error:</b> Cannot install or uninstall - please verify you put this in the same place as SMF\'s index.php.');

// Mod db-settings
if (!empty($context['uninstalling']))
{
	// Remove abm db-settings
	$mod_settings = array('a_Open_Graph', 'a_Open_Graph_image');
	foreach($mod_settings as $open_graph)
	{
		$smcFunc['db_query']('', '
			DELETE FROM {db_prefix}settings
			WHERE variable = {string:graph}',
			array(
				'graph' => $open_graph,
			)
		);
	}
}
else
{
	// Adding abm db-settings	
	$mod_settings = array(
		'a_Open_Graph' => 0,
		'a_Open_Graph_image'=> 'thum_opf.png',
	);
	updateSettings($mod_settings);
}

// Prepare hooks
$hook_functions = array(
	'integrate_pre_include' => '$sourcedir/open_g_hook.php',
	'integrate_modify_modifications' => 'Graph_sub_actions',
	'integrate_admin_areas' => 'Graph_admin_areas',
	'integrate_menu_buttons' => 'Graph_menu_buttons',
	);

// Adding or removing hooks
if (!empty($context['uninstalling']))
	$request = 'remove_integration_function';
else
	$request = 'add_integration_function';

// Carrying out the hooks
foreach ($hook_functions as $hook => $function)
	$request($hook, $function);

?>