<?php
/*
 * @package Open graph facebook
 * @version 0.01
 * @Author:dhayzon /www.dhayzon.com
 * @copyright Copyright (C) 2016, Dahyzon
 * @All rights reserved. 
 * @This SMF modification is subject to the BSD  License
 */


if (!defined('SMF'))
	die('Hacking attempt...');

function Graph_admin_areas(&$areas)
{	
	global $txt;
	
	loadLanguage('openGraph');	
	
	$areas['config']['areas']['modsettings']['subsections']['openGraph'] = array($txt['uog_name']);
}
	
function Graph_sub_actions(&$sub_actions)
{	
	
	$sub_actions['openGraph'] = 'Graph_sub_settings';	
}

function Graph_sub_settings($return_config = false)
{
	global $context, $txt, $scripturl;
	

	// Admin layout
	$config_vars = array(		  
		array(
			'check',
			'a_Open_Graph'
			 ),

		array(
			'text',
			'subtext' => $txt['a_Open_Graph_des'],
			'a_Open_Graph_image',
			'size' =>40,
		 ),
	);
	
	
	if ($return_config)		
		return $config_vars;

	$context['post_url'] = $scripturl . '?action=admin;area=modsettings;save;sa=openGraph';	
		
	if (empty($config_vars))
	{
		$context['settings_save_dont_show'] = false;
		$context['settings_message'] = '<div align="center">' . $txt['a_Open_Graph_emty'] . '</div>';
		return prepareDBSettingContext($config_vars);	
	}

		// Attempt to figure out if the admin is trying to break things.
	$context['settings_save_onclick'] = 'return document.getElementById(\'a_Open_Graph_image\').value == 0 ? confirm(\'' . $txt['a_Open_Graph_emty'] . '\') : true;';
	
	// Save admin settings
	if (isset($_GET['save']))
	{		 
		checkSession();			
				
		$context['save_vars'] = $config_vars;
		
		saveDBSettings($context['save_vars']);
		
		redirectexit('action=admin;area=modsettings;sa=openGraph');	
	}	
 
	prepareDBSettingContext($config_vars);
}
// Show credits
function Graph_menu_buttons()
{
	global  $context, $modSettings, $scripturl;

	if (empty($modSettings['a_Open_Graph']))
		return;
	
	if (isset($context['current_action']) && $context['current_action'] == 'credits')
		$context['copyrights']['mods'][] = '<a href="http://dhayzon.com">Open Graph</a> | <a href="http://www.dhayzon.com" title="Dhayzon inc">&copy 2016 Dhayzon</a>';
 
	if (isset($context['topic_first_message']) && $context['topic_first_message']!==null) 
	{	  
 	   $idPost= $context['topic_first_message'];
	   $idTopic= $context['current_topic'];
	   $array = uGetpost_ogg($idPost);
		 foreach($array as $post) {
			$content1 = str_replace("[", " <", $post['body']);
			$content2 = str_replace("]", "> ", $content1); 
			$content3 = strip_tags($content2);
			$regex = "@((https?://)?([-\w]+\.[-\w\.]+)+\w(:\d+)?(/([-\w/_\.]*(\?\S+)?)?)*)@";
			$preview = preg_replace($regex, ' ', $content3);
			$tEmty = preg_replace('/\s\s+|&nbsp;|&quot;/', ' ', $preview);
	 		$preview2 = substr($tEmty,0,300);
		   	$ogImage =$content3;

			if(preg_match('/(https?:\/\/\S+\.(?:jpg|png|gif))\s+/',$ogImage,$match))
				$uSimage= $match[1];
			else
				$uSimage =   $modSettings['a_Open_Graph_image'];
	  }
	 
	

	// Add our css and js files. Dear and lovely mod authors, if you're going to use $context['html_headers'] MAKE SURE you append your data .= instead of re-declaring the var! and don't forget to add a new line and proper indentation too!
	$context['html_headers'] .= '
	<meta property="og:url" content="'.$scripturl.'?topic='.$idTopic.'" />
	<meta property="og:type"  content="article" />
	<meta property="og:title"  content="'.$context['subject'].'" />
	<meta property="og:description"  content="'.$preview2.'" />
	<meta property="og:image"  content="'.$uSimage.'" />
	';
	}

}

 function uGetpost_ogg($id)
 {

	global $smcFunc;

	$request = $smcFunc['db_query']('', '
		SELECT  id_msg, body
		FROM  {db_prefix}messages
		WHERE id_msg ='.(int)$id
		);
	
	$posts = array();

 while ($row = $smcFunc['db_fetch_assoc']($request))
	{
			// Build the array.
			$posts[] = array(
				'body' => $row['body'],
		 
			);
	}

	$smcFunc['db_free_result']($request);
 	 
	return   $posts;
 }
?>